package com.cicdi.notify;

import java.io.Serializable;
import java.util.Map;
import java.util.Optional;

/**
 * 通知配置属性
 *
 * @author xueye
 */
public class NotifierProperties implements Serializable {

    /**
     * 通知配置属性唯一标识
     */
    private String id;

    /**
     * 通知类型
     *
     * @see NotifyType
     */
    private String type;

    /**
     * 通知服务商标识
     */
    private String provider;

    /**
     * 通知配置名称
     */
    private String name;

    /**
     * 通知配置内容
     *
     * @see NotifierProvider
     */
    private Map<String, Object> configuration;


    /**
     * 获取通知配置值
     *
     * @param key 通知配置项
     * @return 通知配置项值
     */
    public Optional<Object> getConfig(String key) {
        return Optional.ofNullable(configuration)
                .map(conf -> conf.get(key));
    }

    /**
     * 获取通知配置值
     *
     * @param key 通知配置项
     * @return 通知配置项值
     */
    public Object getConfigOrNull(String key) {
        return Optional.ofNullable(configuration)
                .map(conf -> conf.get(key))
                .orElse(null);
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getProvider() {
        return provider;
    }

    public void setProvider(String provider) {
        this.provider = provider;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Map<String, Object> getConfiguration() {
        return configuration;
    }

    public void setConfiguration(Map<String, Object> configuration) {
        this.configuration = configuration;
    }

}
