package com.cicdi.notify.wechat.corp;

import com.alibaba.fastjson.JSON;
import com.cicdi.notify.*;
import com.cicdi.notify.template.Template;
import com.cicdi.notify.template.TemplateManager;
import com.cicdi.notify.template.TemplateProperties;
import com.cicdi.notify.template.TemplateProvider;
import com.cicdi.notify.wechat.WechatProvider;

import java.util.Map;

public class WechatCorpNotifierProvider implements NotifierProvider, TemplateProvider {

    private final TemplateManager templateManager;

    public WechatCorpNotifierProvider(TemplateManager templateManager) {
        this.templateManager = templateManager;
    }

//    public static final DefaultConfigMetadata notifierConfig = new DefaultConfigMetadata("通知配置", "")
//            .add("corpId", "corpId", "", new StringType().expand(ConfigMetadataConstants.required.value(true)))
//            .add("corpSecret", "corpSecret", "", new StringType());
//
//    public static final DefaultConfigMetadata templateConfig = new DefaultConfigMetadata("模版配置", "")
//            .add("agentId", "应用ID", "", new StringType().expand(ConfigMetadataConstants.required.value(true)))
//            .add("toUser", "收信人ID", "与部门ID不能同时为空", new StringType())
//            .add("toParty", "收信部门ID", "与收信人ID不能同时为空", new StringType())
//            .add("toTag", "按标签推送", "", new StringType())
//            .add("message", "内容", "最大不超过500字", new StringType().expand(ConfigMetadataConstants.maxLength.value(500L)));

    @Override
    public NotifyType getType() {
        return DefaultNotifyType.wechat;
    }

    @Override
    public Provider getProvider() {
        return WechatProvider.corpMessage;
    }

    @Override
    public Template createTemplate(TemplateProperties properties) {
        return JSON.parseObject(properties.getTemplate(), WechatCorpTemplate.class);
    }

    @Override
    public WechatCorpNotifier createNotifier(NotifierProperties properties) {
        Map<String, Object> config = properties.getConfiguration();
        WechatCorpProperties wechatCorpProperties = new WechatCorpProperties();
        wechatCorpProperties.setCorpId((String) config.get("corpId"));
        wechatCorpProperties.setCorpSecret((String) config.get("corpSecret"));
        return new WechatCorpNotifier(properties.getId(), wechatCorpProperties, templateManager);
    }

//    @Override
//    public ConfigMetadata getNotifierConfigMetadata() {
//        return notifierConfig;
//    }
//
//    @Override
//    public ConfigMetadata getTemplateConfigMetadata() {
//        return templateConfig;
//    }
}
