package com.cicdi.notify.wechat.subscription;

import com.alibaba.fastjson.JSON;
import com.cicdi.notify.*;
import com.cicdi.notify.template.Template;
import com.cicdi.notify.template.TemplateProperties;
import com.cicdi.notify.template.TemplateProvider;
import com.cicdi.notify.wechat.WechatProvider;

/**
 * 微信公众号通知器提供商
 *
 * @author xueye
 */
public class WechatSubscriptionNotifierProvider implements NotifierProvider, TemplateProvider {
    @Override
    public NotifyType getType() {
        return DefaultNotifyType.wechat;
    }

    @Override
    public Provider getProvider() {
        return WechatProvider.corpMessage;
    }

    @Override
    public Template createTemplate(TemplateProperties properties) {
        return JSON.parseObject(String.valueOf(properties), WechatSubscriptionTemplate.class);
    }

    @Override
    public Notifier<? extends Template> createNotifier(NotifierProperties properties) {
        return null;
    }
}
